/**
 * 
 */
package org.mycompany.connector;

import java.util.ArrayList;
import java.util.List;

import org.bonitasoft.engine.api.IdentityAPI;
import org.bonitasoft.engine.connector.ConnectorValidationException;
import org.bonitasoft.engine.filter.UserFilterException;
import org.bonitasoft.engine.identity.Group;
import org.bonitasoft.engine.identity.User;
import org.bonitasoft.engine.identity.UserCriterion;
import org.bonitasoft.engine.identity.UserMembership;

/**
 *The actor filter execution will follow the steps
 * 1 - setInputParameters() --> the actor filter receives input parameters values
 * 2 - validateInputParameters() --> the actor filter can validate input parameters values
 * 3 - filter(final String actorName) --> execute the user filter
 * 4 - shouldAutoAssignTaskIfSingleResult() --> auto-assign the task if filter returns a single result
 */
public class BestimmterOderalleAbernichtantragstellerImpl extends
		AbstractBestimmterOderalleAbernichtantragstellerImpl {

	@Override
	public void validateInputParameters() throws ConnectorValidationException {
		//TODO validate input parameters here 
	
	}

	@Override
	public List<Long> filter(final String actorName) throws UserFilterException {
		
		
		boolean iDisValid = false;
		List<Long> userList = new ArrayList<Long>();
		IdentityAPI ia = getAPIAccessor().getIdentityAPI();
		
		if(getInputParameter("userID")!=null){
			try{
				Long userID = (Long)getInputParameter("userID");
				User u = ia.getUser(userID);
				iDisValid = true;
				userList.add(userID);
			} catch(Exception e){
				iDisValid = false;
			}
		}
		
		if(!iDisValid){
			try{
				Group einkauf = ia.getGroupByPath("/Unternehmen/Einkauf");
				List<UserMembership> membershipList = ia.getUserMembershipsByGroup(einkauf.getId(), 0, 1000);
				for(UserMembership um:membershipList){
					if(um.getRoleName().equals("Mitarbeiter")){
						userList.add(um.getUserId());
					}
				}
				Long initiatorID = getAPIAccessor().getProcessAPI().getProcessInstance(getExecutionContext().getProcessInstanceId()).getStartedBy();
				userList.remove(initiatorID);
			} catch (Exception e){
			}
		}
		
		return userList;
	
	}

	@Override
	public boolean shouldAutoAssignTaskIfSingleResult() {
		// If this method returns true, the step will be assigned to 
		//the user if there is only one result returned by the filter method
		return super.shouldAutoAssignTaskIfSingleResult();
	
	}

}
